SystemOrganization addCategory: 'ConfigurationOfSewaf'!

Object subclass: #ConfigurationOfSewaf
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSewaf'!

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
project

	^self new project! !

!ConfigurationOfSewaf class methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/24/2015 17:57'!
baseline0921: spec
	<version: '0.921-baseline'>

	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/SEWAF'.
		spec project: 'Seaside3' with: [
			spec repository: 'http://www.smalltalkhub.com/mc/Seaside/MetacelloConfigurations/main';
				versionString: #stable;
				className: 'ConfigurationOfSeaside3';
				file: 'ConfigurationOfSeaside3';
				loads: #('Core').
				].
		spec 
			package: 'SEWAF' with: [spec requires: 'Seaside3'].
	].! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/24/2015 17:54'!
baseline0939: spec
	<version: '0.939-baseline'>

	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/SEWAF'.
		spec project: 'Seaside3' with: [
			spec repository: 'http://www.smalltalkhub.com/mc/Seaside/MetacelloConfigurations/main';
				versionString: #stable;
				className: 'ConfigurationOfSeaside3';
				file: 'ConfigurationOfSeaside3';
				loads: #('Core').
				].
		spec 
			package: 'SEWAF' with: [spec requires: 'Seaside3'].
	].! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/25/2015 05:28'!
bleedingEdge: spec
	<symbolicVersion: #'bleedingEdge'>

	spec for: #'common' version: '0.939-baseline'.! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 05/31/2014 11:57'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/25/2015 05:28'!
release: spec
	<symbolicVersion: #'release'>

	spec for: #common version: '0.939'.! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/25/2015 05:28'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #common version: '0.939'.! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 12/20/2014 08:06'!
version0921: spec
	<version: '0.921' imports: #('0.921-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'brunobb'.
		spec project: 'Seaside3' with: [
			spec loads: #('Core');
				versionString: #stable.].

		spec package: 'SEWAF' with: 'SEWAF-BrunoBB-0.921'.

	]! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 12/22/2014 15:46'!
version0934: spec
	<version: '0.934' imports: #('0.921-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'brunobb'.
		spec project: 'Seaside3' with: [
			spec loads: #('Core');
				versionString: #stable.].

		spec package: 'SEWAF' with: 'SEWAF-BrunoBB-0.934'.

	]! !

!ConfigurationOfSewaf methodsFor: 'other' stamp: 'BrunoBB 03/24/2015 17:55'!
version0939: spec
	<version: '0.939' imports: #('0.939-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'brunobb'.
		spec project: 'Seaside3' with: [
			spec loads: #('Core');
				versionString: #stable.].

		spec package: 'SEWAF' with: 'SEWAF-BrunoBB-0.939'.

	]! !
